diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index bb85b5e52a..b7b7c952a7 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -2789,183 +2779,183 @@ CreateCommandTag(Node *parsetree)
 				case VAR_SET_CURRENT:
 				case VAR_SET_DEFAULT:
 				case VAR_SET_MULTI:
-					tag = "SET";
+					tag = COMMANDTAG_SET;
 					break;
 				case VAR_RESET:
 				case VAR_RESET_ALL:
-					tag = "RESET";
+					tag = COMMANDTAG_RESET;
 					break;
 				default:
-					tag = "???";
+					tag = COMMANDTAG_UNKNOWN;
 			}
 			break;
 
 		case T_VariableShowStmt:
-			tag = "SHOW";
+			tag = COMMANDTAG_SHOW;
 			break;
 
 		case T_DiscardStmt:
 			switch (((DiscardStmt *) parsetree)->target)
 			{
 				case DISCARD_ALL:
-					tag = "DISCARD ALL";
+					tag = COMMANDTAG_DISCARD_ALL;
 					break;
 				case DISCARD_PLANS:
-					tag = "DISCARD PLANS";
+					tag = COMMANDTAG_DISCARD_PLANS;
 					break;
 				case DISCARD_TEMP:
-					tag = "DISCARD TEMP";
+					tag = COMMANDTAG_DISCARD_TEMP;
 					break;
 				case DISCARD_SEQUENCES:
-					tag = "DISCARD SEQUENCES";
+					tag = COMMANDTAG_DISCARD_SEQUENCES;
 					break;
 				default:
-					tag = "???";
+					tag = COMMANDTAG_UNKNOWN;
 			}
 			break;
 
 		case T_CreateTransformStmt:
-			tag = "CREATE TRANSFORM";
+			tag = COMMANDTAG_CREATE_TRANSFORM;
 			break;
 
 		case T_CreateTrigStmt:
-			tag = "CREATE TRIGGER";
+			tag = COMMANDTAG_CREATE_TRIGGER;
 			break;
 
 		case T_CreateEventTrigStmt:
-			tag = "CREATE EVENT TRIGGER";
+			tag = COMMANDTAG_CREATE_EVENT_TRIGGER;
 			break;
 
 		case T_AlterEventTrigStmt:
-			tag = "ALTER EVENT TRIGGER";
+			tag = COMMANDTAG_ALTER_EVENT_TRIGGER;
 			break;
 
 		case T_CreatePLangStmt:
-			tag = "CREATE LANGUAGE";
+			tag = COMMANDTAG_CREATE_LANGUAGE;
 			break;
 
 		case T_CreateRoleStmt:
-			tag = "CREATE ROLE";
+			tag = COMMANDTAG_CREATE_ROLE;
 			break;
 
 		case T_AlterRoleStmt:
-			tag = "ALTER ROLE";
+			tag = COMMANDTAG_ALTER_ROLE;
 			break;
 
 		case T_AlterRoleSetStmt:
-			tag = "ALTER ROLE";
+			tag = COMMANDTAG_ALTER_ROLE;
 			break;
 
 		case T_DropRoleStmt:
-			tag = "DROP ROLE";
+			tag = COMMANDTAG_DROP_ROLE;
 			break;
 
 		case T_DropOwnedStmt:
-			tag = "DROP OWNED";
+			tag = COMMANDTAG_DROP_OWNED;
 			break;
 
 		case T_ReassignOwnedStmt:
-			tag = "REASSIGN OWNED";
+			tag = COMMANDTAG_REASSIGN_OWNED;
 			break;
 
 		case T_LockStmt:
-			tag = "LOCK TABLE";
+			tag = COMMANDTAG_LOCK_TABLE;
 			break;
 
 		case T_ConstraintsSetStmt:
-			tag = "SET CONSTRAINTS";
+			tag = COMMANDTAG_SET_CONSTRAINTS;
 			break;
 
 		case T_CheckPointStmt:
-			tag = "CHECKPOINT";
+			tag = COMMANDTAG_CHECKPOINT;
 			break;
 
 		case T_ReindexStmt:
-			tag = "REINDEX";
+			tag = COMMANDTAG_REINDEX;
 			break;
 
 		case T_CreateConversionStmt:
-			tag = "CREATE CONVERSION";
+			tag = COMMANDTAG_CREATE_CONVERSION;
 			break;
 
 		case T_CreateCastStmt:
-			tag = "CREATE CAST";
+			tag = COMMANDTAG_CREATE_CAST;
 			break;
 
 		case T_CreateOpClassStmt:
-			tag = "CREATE OPERATOR CLASS";
+			tag = COMMANDTAG_CREATE_OPERATOR_CLASS;
 			break;
 
 		case T_CreateOpFamilyStmt:
-			tag = "CREATE OPERATOR FAMILY";
+			tag = COMMANDTAG_CREATE_OPERATOR_FAMILY;
 			break;
 
 		case T_AlterOpFamilyStmt:
-			tag = "ALTER OPERATOR FAMILY";
+			tag = COMMANDTAG_ALTER_OPERATOR_FAMILY;
 			break;
 
 		case T_AlterOperatorStmt:
-			tag = "ALTER OPERATOR";
+			tag = COMMANDTAG_ALTER_OPERATOR;
 			break;
 
 		case T_AlterTSDictionaryStmt:
-			tag = "ALTER TEXT SEARCH DICTIONARY";
+			tag = COMMANDTAG_ALTER_TEXT_SEARCH_DICTIONARY;
 			break;
 
 		case T_AlterTSConfigurationStmt:
-			tag = "ALTER TEXT SEARCH CONFIGURATION";
+			tag = COMMANDTAG_ALTER_TEXT_SEARCH_CONFIGURATION;
 			break;
 
 		case T_CreatePolicyStmt:
-			tag = "CREATE POLICY";
+			tag = COMMANDTAG_CREATE_POLICY;
 			break;
 
 		case T_AlterPolicyStmt:
-			tag = "ALTER POLICY";
+			tag = COMMANDTAG_ALTER_POLICY;
 			break;
 
 		case T_CreateAmStmt:
-			tag = "CREATE ACCESS METHOD";
+			tag = COMMANDTAG_CREATE_ACCESS_METHOD;
 			break;
 
 		case T_CreatePublicationStmt:
-			tag = "CREATE PUBLICATION";
+			tag = COMMANDTAG_CREATE_PUBLICATION;
 			break;
 
 		case T_AlterPublicationStmt:
-			tag = "ALTER PUBLICATION";
+			tag = COMMANDTAG_ALTER_PUBLICATION;
 			break;
 
 		case T_CreateSubscriptionStmt:
-			tag = "CREATE SUBSCRIPTION";
+			tag = COMMANDTAG_CREATE_SUBSCRIPTION;
 			break;
 
 		case T_AlterSubscriptionStmt:
-			tag = "ALTER SUBSCRIPTION";
+			tag = COMMANDTAG_ALTER_SUBSCRIPTION;
 			break;
 
 		case T_DropSubscriptionStmt:
-			tag = "DROP SUBSCRIPTION";
+			tag = COMMANDTAG_DROP_SUBSCRIPTION;
 			break;
 
 		case T_AlterCollationStmt:
-			tag = "ALTER COLLATION";
+			tag = COMMANDTAG_ALTER_COLLATION;
 			break;
 
 		case T_PrepareStmt:
-			tag = "PREPARE";
+			tag = COMMANDTAG_PREPARE;
 			break;
 
 		case T_ExecuteStmt:
-			tag = "EXECUTE";
+			tag = COMMANDTAG_EXECUTE;
 			break;
 
 		case T_CreateStatsStmt:
-			tag = "CREATE STATISTICS";
+			tag = COMMANDTAG_CREATE_STATISTICS;
 			break;
 
 		case T_AlterStatsStmt:
-			tag = "ALTER STATISTICS";
+			tag = COMMANDTAG_ALTER_STATISTICS;
 			break;
 
 		case T_DeallocateStmt:
@@ -2973,9 +2963,9 @@ CreateCommandTag(Node *parsetree)
 				DeallocateStmt *stmt = (DeallocateStmt *) parsetree;
 
 				if (stmt->name == NULL)
-					tag = "DEALLOCATE ALL";
+					tag = COMMANDTAG_DEALLOCATE_ALL;
 				else
-					tag = "DEALLOCATE";
+					tag = COMMANDTAG_DEALLOCATE;
 			}
 			break;
 
@@ -2999,33 +2989,33 @@ CreateCommandTag(Node *parsetree)
 							switch (((PlanRowMark *) linitial(stmt->rowMarks))->strength)
 							{
 								case LCS_FORKEYSHARE:
-									tag = "SELECT FOR KEY SHARE";
+									tag = COMMANDTAG_SELECT_FOR_KEY_SHARE;
 									break;
 								case LCS_FORSHARE:
-									tag = "SELECT FOR SHARE";
+									tag = COMMANDTAG_SELECT_FOR_SHARE;
 									break;
 								case LCS_FORNOKEYUPDATE:
-									tag = "SELECT FOR NO KEY UPDATE";
+									tag = COMMANDTAG_SELECT_FOR_NO_KEY_UPDATE;
 									break;
 								case LCS_FORUPDATE:
-									tag = "SELECT FOR UPDATE";
+									tag = COMMANDTAG_SELECT_FOR_UPDATE;
 									break;
 								default:
-									tag = "SELECT";
+									tag = COMMANDTAG_SELECT;
 									break;
 							}
 						}
 						else
-							tag = "SELECT";
+							tag = COMMANDTAG_SELECT;
 						break;
 					case CMD_UPDATE:
-						tag = "UPDATE";
+						tag = COMMANDTAG_UPDATE;
 						break;
 					case CMD_INSERT:
-						tag = "INSERT";
+						tag = COMMANDTAG_INSERT;
 						break;
 					case CMD_DELETE:
-						tag = "DELETE";
+						tag = COMMANDTAG_DELETE;
 						break;
 					case CMD_UTILITY:
 						tag = CreateCommandTag(stmt->utilityStmt);
@@ -3033,7 +3023,7 @@ CreateCommandTag(Node *parsetree)
 					default:
 						elog(WARNING, "unrecognized commandType: %d",
 							 (int) stmt->commandType);
-						tag = "???";
+						tag = COMMANDTAG_UNKNOWN;
 						break;
 				}
 			}
@@ -3059,33 +3049,33 @@ CreateCommandTag(Node *parsetree)
 							switch (((RowMarkClause *) linitial(stmt->rowMarks))->strength)
 							{
 								case LCS_FORKEYSHARE:
-									tag = "SELECT FOR KEY SHARE";
+									tag = COMMANDTAG_SELECT_FOR_KEY_SHARE;
 									break;
 								case LCS_FORSHARE:
-									tag = "SELECT FOR SHARE";
+									tag = COMMANDTAG_SELECT_FOR_SHARE;
 									break;
 								case LCS_FORNOKEYUPDATE:
-									tag = "SELECT FOR NO KEY UPDATE";
+									tag = COMMANDTAG_SELECT_FOR_NO_KEY_UPDATE;
 									break;
 								case LCS_FORUPDATE:
-									tag = "SELECT FOR UPDATE";
+									tag = COMMANDTAG_SELECT_FOR_UPDATE;
 									break;
 								default:
-									tag = "???";
+									tag = COMMANDTAG_UNKNOWN;
 									break;
 							}
 						}
 						else
-							tag = "SELECT";
+							tag = COMMANDTAG_SELECT;
 						break;
 					case CMD_UPDATE:
-						tag = "UPDATE";
+						tag = COMMANDTAG_UPDATE;
 						break;
 					case CMD_INSERT:
-						tag = "INSERT";
+						tag = COMMANDTAG_INSERT;
 						break;
 					case CMD_DELETE:
-						tag = "DELETE";
+						tag = COMMANDTAG_DELETE;
 						break;
 					case CMD_UTILITY:
 						tag = CreateCommandTag(stmt->utilityStmt);
@@ -3093,7 +3083,7 @@ CreateCommandTag(Node *parsetree)
 					default:
 						elog(WARNING, "unrecognized commandType: %d",
 							 (int) stmt->commandType);
-						tag = "???";
+						tag = COMMANDTAG_UNKNOWN;
 						break;
 				}
 			}
@@ -3102,7 +3092,7 @@ CreateCommandTag(Node *parsetree)
 		default:
 			elog(WARNING, "unrecognized node type: %d",
 				 (int) nodeTag(parsetree));
-			tag = "???";
+			tag = COMMANDTAG_UNKNOWN;
 			break;
 	}
 
diff --git a/src/backend/utils/.gitignore b/src/backend/utils/.gitignore
index 0685556959..7d6dfa45a5 100644
--- a/src/backend/utils/.gitignore
+++ b/src/backend/utils/.gitignore
@@ -1,6 +1,9 @@
+/commandtag_behavior.h
+/commandtag_enum.h
 /fmgrtab.c
 /fmgroids.h
 /fmgrprotos.h
 /fmgr-stamp
+/commandtag-stamp
 /probes.h
 /errcodes.h
diff --git a/src/backend/utils/Makefile b/src/backend/utils/Makefile
index b91028ddfd..3c433cf249 100644
--- a/src/backend/utils/Makefile
+++ b/src/backend/utils/Makefile
@@ -13,7 +13,7 @@ subdir = src/backend/utils
 top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
-OBJS        = fmgrtab.o
+OBJS        = commandtag.o fmgrtab.o
 SUBDIRS     = adt cache error fmgr hash init mb misc mmgr resowner sort time
 
 # location of Catalog.pm
@@ -23,13 +23,13 @@ include $(top_srcdir)/src/backend/common.mk
 
 all: distprep probes.h generated-header-symlinks
 
-distprep: fmgr-stamp errcodes.h
+distprep: commandtag-stamp fmgr-stamp errcodes.h
 
 .PHONY: generated-header-symlinks
 
 generated-header-symlinks: $(top_builddir)/src/include/utils/header-stamp $(top_builddir)/src/include/utils/probes.h
 
-$(SUBDIRS:%=%-recursive): fmgr-stamp errcodes.h
+$(SUBDIRS:%=%-recursive): commandtag-stamp fmgr-stamp errcodes.h
 
 # fmgr-stamp records the last time we ran Gen_fmgrtab.pl.  We don't rely on
 # the timestamps of the individual output files, because the Perl script
@@ -38,6 +38,10 @@ fmgr-stamp: Gen_fmgrtab.pl $(catalogdir)/Catalog.pm $(top_srcdir)/src/include/ca
 	$(PERL) -I $(catalogdir) $< --include-path=$(top_srcdir)/src/include/ $(top_srcdir)/src/include/catalog/pg_proc.dat
 	touch $@
 
+commandtag-stamp: gencommandtag.pl $(top_srcdir)/src/include/utils/commandtag.dat
+	$(PERL) $<
+	touch $@
+
 errcodes.h: $(top_srcdir)/src/backend/utils/errcodes.txt generate-errcodes.pl
 	$(PERL) $(srcdir)/generate-errcodes.pl $< > $@
 
@@ -62,10 +66,10 @@ endif
 # These generated headers must be symlinked into builddir/src/include/,
 # using absolute links for the reasons explained in src/backend/Makefile.
 # We use header-stamp to record that we've done this because the symlinks
-# themselves may appear older than fmgr-stamp.
-$(top_builddir)/src/include/utils/header-stamp: fmgr-stamp errcodes.h
+# themselves may appear older than commandtag-stamp and fmgr-stamp.
+$(top_builddir)/src/include/utils/header-stamp: commandtag-stamp fmgr-stamp errcodes.h
 	prereqdir=`cd '$(dir $<)' >/dev/null && pwd` && \
-	cd '$(dir $@)' && for file in fmgroids.h fmgrprotos.h errcodes.h; do \
+	cd '$(dir $@)' && for file in commandtag_enum.h commandtag_behavior.h fmgroids.h fmgrprotos.h errcodes.h; do \
 	  rm -f $$file && $(LN_S) "$$prereqdir/$$file" . ; \
 	done
 	touch $@
@@ -87,10 +91,10 @@ installdirs:
 uninstall-data:
 	rm -f $(addprefix '$(DESTDIR)$(datadir)'/, errcodes.txt)
 
-# fmgroids.h, fmgrprotos.h, fmgrtab.c, fmgr-stamp, and errcodes.h are in the
+# fmgroids.h, fmgrprotos.h, fmgrtab.c, commandtag-stamp, fmgr-stamp, and errcodes.h are in the
 # distribution tarball, so they are not cleaned here.
 clean:
 	rm -f probes.h
 
 maintainer-clean: clean
-	rm -f fmgroids.h fmgrprotos.h fmgrtab.c fmgr-stamp errcodes.h
+	rm -f commandtag_enum.h commandtag_behavior.h commandtag-stamp fmgroids.h fmgrprotos.h fmgrtab.c fmgr-stamp errcodes.h
diff --git a/src/backend/utils/cache/evtcache.c b/src/backend/utils/cache/evtcache.c
index 1b63048a77..a960d7ca80 100644
--- a/src/backend/utils/cache/evtcache.c
+++ b/src/backend/utils/cache/evtcache.c
@@ -51,7 +51,7 @@ static EventTriggerCacheStateType EventTriggerCacheState = ETCS_NEEDS_REBUILD;
 static void BuildEventTriggerCache(void);
 static void InvalidateEventCacheCallback(Datum arg,
 										 int cacheid, uint32 hashvalue);
-static int	DecodeTextArrayToCString(Datum array, char ***cstringp);
+static void	DecodeTextArrayToBitmapset(Datum array, Bitmapset **bms);
 
 /*
  * Search the event cache by trigger event.
@@ -180,10 +180,7 @@ BuildEventTriggerCache(void)
 		evttags = heap_getattr(tup, Anum_pg_event_trigger_evttags,
 							   RelationGetDescr(rel), &evttags_isnull);
 		if (!evttags_isnull)
-		{
-			item->ntags = DecodeTextArrayToCString(evttags, &item->tag);
-			qsort(item->tag, item->ntags, sizeof(char *), pg_qsort_strcmp);
-		}
+			DecodeTextArrayToBitmapset(evttags, &item->tagset);
 
 		/* Add to cache entry. */
 		entry = hash_search(cache, &event, HASH_ENTER, &found);
@@ -215,18 +212,18 @@ BuildEventTriggerCache(void)
 }
 
 /*
- * Decode text[] to an array of C strings.
+ * Decode text[] to a Bitmapset of CommandTags.
  *
  * We could avoid a bit of overhead here if we were willing to duplicate some
  * of the logic from deconstruct_array, but it doesn't seem worth the code
  * complexity.
  */
-static int
-DecodeTextArrayToCString(Datum array, char ***cstringp)
+static void
+DecodeTextArrayToBitmapset(Datum array, Bitmapset **tagset)
 {
 	ArrayType  *arr = DatumGetArrayTypeP(array);
 	Datum	   *elems;
-	char	  **cstring;
+	Bitmapset  *bms;
 	int			i;
 	int			nelems;
 
@@ -234,13 +231,15 @@ DecodeTextArrayToCString(Datum array, char ***cstringp)
 		elog(ERROR, "expected 1-D text array");
 	deconstruct_array(arr, TEXTOID, -1, false, 'i', &elems, NULL, &nelems);
 
-	cstring = palloc(nelems * sizeof(char *));
-	for (i = 0; i < nelems; ++i)
-		cstring[i] = TextDatumGetCString(elems[i]);
+	for (bms = NULL, i = 0; i < nelems; ++i)
+	{
+		char *str = TextDatumGetCString(elems[i]);
+		bms = bms_add_member(bms, GetCommandTagEnum(str));
+		pfree(str);
+	}
 
 	pfree(elems);
-	*cstringp = cstring;
-	return nelems;
+	*tagset = bms;
 }
 
 /*
diff --git a/src/backend/utils/cache/plancache.c b/src/backend/utils/cache/plancache.c
index c47be0ba4c..53401bd4e9 100644
--- a/src/backend/utils/cache/plancache.c
+++ b/src/backend/utils/cache/plancache.c
@@ -163,7 +163,7 @@ InitPlanCache(void)
 CachedPlanSource *
 CreateCachedPlan(RawStmt *raw_parse_tree,
 				 const char *query_string,
-				 const char *commandTag)
+				 CommandTag commandTag)
 {
 	CachedPlanSource *plansource;
 	MemoryContext source_context;
@@ -246,7 +246,7 @@ CreateCachedPlan(RawStmt *raw_parse_tree,
 CachedPlanSource *
 CreateOneShotCachedPlan(RawStmt *raw_parse_tree,
 						const char *query_string,
-						const char *commandTag)
+						CommandTag commandTag)
 {
 	CachedPlanSource *plansource;
 
diff --git a/src/backend/utils/commandtag.c b/src/backend/utils/commandtag.c
new file mode 100644
index 0000000000..c629eca608
--- /dev/null
+++ b/src/backend/utils/commandtag.c
@@ -0,0 +1,119 @@
+/*-------------------------------------------------------------------------
+ *
+ * commandtag.c
+ *	  Data and routines for commandtag names and enumeration.
+ *
+ * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * IDENTIFICATION
+ *	  src/backend/utils/commandtag.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "c.h"
+#include "miscadmin.h"
+#include "utils/commandtag.h"
+#include "utils/commandtag_enum.h"
+#include "utils/commandtag_behavior.h"
+
+static const unsigned int tag_behavior_length = lengthof(tag_behavior);
+
+static inline bool
+PG_VALID_COMMANDTAG(CommandTag commandTag)
+{
+	return (commandTag >= FIRST_COMMANDTAG &&
+			commandTag <= LAST_COMMANDTAG);
+}
+
+void
+InitializeQueryCompletion(QueryCompletion *qc)
+{
+	qc->commandTag = COMMANDTAG_UNKNOWN;
+	qc->nprocessed = 0;
+}
+
+const char *
+GetCommandTagName(CommandTag commandTag)
+{
+	Assert(PG_VALID_COMMANDTAG(commandTag));
+	return tag_behavior[commandTag].name;
+}
+
+bool
+command_tag_display_last_oid(CommandTag commandTag)
+{
+	Assert(PG_VALID_COMMANDTAG(commandTag));
+	return tag_behavior[commandTag].display_last_oid;
+}
+
+bool
+command_tag_display_rowcount(CommandTag commandTag)
+{
+	Assert(PG_VALID_COMMANDTAG(commandTag));
+	return tag_behavior[commandTag].display_rowcount;
+}
+
+bool
+command_tag_event_trigger_ok(CommandTag commandTag)
+{
+	Assert(PG_VALID_COMMANDTAG(commandTag));
+	return tag_behavior[commandTag].event_trigger_ok;
+}
+
+bool
+command_tag_table_rewrite_ok(CommandTag commandTag)
+{
+	Assert(PG_VALID_COMMANDTAG(commandTag));
+	return tag_behavior[commandTag].table_rewrite_ok;
+}
+
+/*
+ * Search CommandTag by name
+ *
+ * Returns CommandTag, or COMMANDTAG_UNKNOWN if not recognized
+ */
+CommandTag
+GetCommandTagEnum(const char *commandname)
+{
+	const CommandTagBehavior *base, *last, *position;
+	int		 result;
+
+	if (commandname == NULL || *commandname == '\0')
+		return COMMANDTAG_UNKNOWN;
+
+	base = tag_behavior;
+	last = tag_behavior + tag_behavior_length - 1;
+	while (last >= base)
+	{
+		position = base + ((last - base) >> 1);
+		result = pg_strcasecmp(commandname, position->name);
+		if (result == 0)
+			return (CommandTag) (position - tag_behavior);
+		else if (result < 0)
+			last = position - 1;
+		else
+			base = position + 1;
+	}
+	return COMMANDTAG_UNKNOWN;
+}
+
+void
+PreventCommandTagIfReadOnly(CommandTag commandTag)
+{
+	PreventCommandIfReadOnly(GetCommandTagName(commandTag));
+}
+
+void
+PreventCommandTagIfParallelMode(CommandTag commandTag)
+{
+	PreventCommandIfParallelMode(GetCommandTagName(commandTag));
+}
+
+void
+PreventCommandTagDuringRecovery(CommandTag commandTag)
+{
+	PreventCommandDuringRecovery(GetCommandTagName(commandTag));
+}
diff --git a/src/backend/utils/gencommandtag.pl b/src/backend/utils/gencommandtag.pl
new file mode 100755
index 0000000000..434f165305
--- /dev/null
+++ b/src/backend/utils/gencommandtag.pl
@@ -0,0 +1,266 @@
+#!/usr/bin/perl -w
+#----------------------------------------------------------------------
+#
+# gencommandtag.pl
+#    Perl script that generates the commandtag data headers from the
+#    specially formatted commandtag.dat data file.
+#
+# Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+# Portions Copyright (c) 1994, Regents of the University of California
+#
+# src/backend/utils/gencommandtag.pl
+#
+#----------------------------------------------------------------------
+
+use strict;
+use warnings;
+use Getopt::Long;
+
+use File::Basename;
+use File::Spec;
+BEGIN { use lib File::Spec->rel2abs(dirname(__FILE__)); }
+
+use FindBin;
+use lib "$FindBin::RealBin/../catalog/";
+use DataFile;
+
+my $outputdir = '.';
+my $inputfile = '../../include/utils/commandtag.dat';
+
+GetOptions(
+	'inputfile:s'		=> \$inputfile,
+	'outputdir:s'		=> \$outputdir) || usage();
+
+# Sanity check arguments.
+die "input file $inputfile does not exist" unless(-f $inputfile);
+die "output directory $outputdir does not exist" unless(-d $outputdir);
+
+# Make sure paths end with a slash.
+$outputdir .= '/' if (substr($outputdir, -1) ne '/');
+
+my $enumfile = join('', $outputdir, "commandtag_enum.h");
+my $arrayfile = join('', $outputdir, "commandtag_behavior.h");
+
+# Vivify the input data, but be paranoid about eval'ing arbitrary code
+my $data = DataFile::ParseData($inputfile);
+sanity_check_data($data);
+
+# Sort the commandtags based on their stringified representation,
+# not their labels.
+my @sorted = sort { $a->{tagname} cmp $b->{tagname} } @$data;
+
+# Generate all output internally before outputting anything, to avoid
+# partially overwriting generated files under error conditions
+my (@enum_chunks, @behavior_chunks);
+push(@enum_chunks,
+	 boilerplate_header("commandtag_enum.h",
+						"Enumeration of all PostgreSQL command tags.",
+						"src/include/utils/commandtag_enum.h",
+						"COMMANDTAG_ENUM_H"));
+
+push (@enum_chunks, qq(
+typedef enum CommandTag
+{
+#define FIRST_COMMANDTAG COMMANDTAG_$sorted[0]->{taglabel})
+);
+
+push(@behavior_chunks,
+	 boilerplate_header("commandtag_behavior.h",
+						"Array of records defining the behavior of each command tag.",
+						"src/include/utils/commandtag_behavior.h",
+						"COMMANDTAG_BEHAVIOR_H"));
+push (@behavior_chunks, q(
+const CommandTagBehavior tag_behavior[] = {)
+);
+
+for(my $i = 0; $i < scalar(@sorted); $i++)
+{
+	my $rec = $sorted[$i];
+	my $comma = ($i < $#sorted) ? "," : "";
+	my $enumrow = sprintf("\tCOMMANDTAG_%s%s", $rec->{taglabel}, $comma);
+	push(@enum_chunks, $enumrow);
+
+	my $behaviorrow = sprintf("\t[COMMANDTAG_%s] = {", $rec->{taglabel});
+	$behaviorrow .= sprintf("\n\t\t.name = \"%s\"", $rec->{tagname});
+	$behaviorrow .= ",\n\t\t.event_trigger_ok = true" if ($rec->{event_trigger_ok});
+	$behaviorrow .= ",\n\t\t.table_rewrite_ok = true" if ($rec->{table_rewrite_ok});
+	$behaviorrow .= ",\n\t\t.display_rowcount = true" if ($rec->{display_rowcount});
+	$behaviorrow .= ",\n\t\t.display_last_oid = true" if ($rec->{display_last_oid});
+	$behaviorrow .= "\n\t}$comma";
+	push (@behavior_chunks, $behaviorrow);
+}
+
+push(@enum_chunks,
+qq(#define LAST_COMMANDTAG COMMANDTAG_$sorted[$#sorted]->{taglabel}
+}			CommandTag;),
+	boilerplate_footer("COMMANDTAG_ENUM_H")
+	);
+
+push(@behavior_chunks,
+q(};
+StaticAssertDecl(FIRST_COMMANDTAG == (CommandTag)0, "first command tag");
+StaticAssertDecl(lengthof(tag_behavior) == (LAST_COMMANDTAG + 1),
+				 "array length mismatch");),
+	boilerplate_footer("COMMANDTAG_BEHAVIOR_H")
+	);
+
+my $enum_out = IO::File->new(">$enumfile")
+	or die "Cannot write $enumfile: $!";
+$enum_out->print(join("\n", @enum_chunks));
+$enum_out->close();
+
+my $array_out = IO::File->new(">$arrayfile")
+	or die "Cannot write $arrayfile: $!";
+$array_out->print(join("\n", @behavior_chunks));
+$array_out->close();
+
+# Check that the records from the data file look reasonable.
+#
+# Some of the checks here cannot fail, because they check things that were
+# already checked before eval'ing the inputfile data.  We check anyway, for
+# future-proofing and because the prior checks were against the stringified
+# form of the data and these checks are against the perl data structures that
+# we revivified, and the possibility of subtle corner cases that entails.
+#
+sub sanity_check_data
+{
+	my ($data) = @_;
+
+	# Verify that at the outermost layer the data file is an array reference
+	dataerror("Malformed input data: expected an array reference",
+			  "The input file should start with a '[' and end with a ']'")
+		unless defined $data and ref($data) and ref($data) =~ m/ARRAY/;
+
+	# Verify that the data array contains only hash references
+	dataerror("Malformed input data: expected an array of hash references",
+			  "The input file array should contain only records in perl hash " .
+			  "reference '{...}' format")
+		if (grep { !ref($_) || ref($_) !~ m/HASH/ } @$data);
+
+	my @required_keys = qw(tagname taglabel);
+	my @flag_keys = qw(event_trigger_ok table_rewrite_ok display_rowcount
+					   display_last_oid);
+	my @expected_keys = (@required_keys, @flag_keys);
+	my %expected_keys = map { $_ => 1 } @expected_keys;
+
+	# Check that each record in the data file contains the required
+	# fields.  If we have only one required field (name or label) but
+	# not the other, we can use the one we have in the error message
+	# to help direct the user to the record which needs correcting.
+	foreach my $href (@$data)
+	{
+		my $preamble = "Malformed input data:";
+		if (defined $href->{taglabel} and length $href->{taglabel})
+		{
+			$preamble .= " Record for commandtag label '$href->{taglabel}':";
+		}
+		elsif (defined $href->{tagname} and length $href->{tagname})
+		{
+			$preamble .= " Record for commandtag name '$href->{tagname}':";
+		}
+
+		foreach my $key (@required_keys)
+		{
+			dataerror("$preamble missing '$key'",
+					  "Each record in the data file should fields for @required_keys")
+				unless(exists $href->{$key});
+			dataerror("$preamble trivial value for '$key'")
+				unless(defined $href->{$key} and length $href->{$key});
+			dataerror("$preamble value of '$key' not uppercase: $href->{$key}")
+				unless($href->{$key} eq uc($href->{$key}));
+		}
+
+		foreach my $key (keys %$href)
+		{
+			dataerror("$preamble non-printable value for '$key'",
+					  "Do not embed non-printable characters such as tabs, form-feeds or newlines")
+				if (grep { ord($_) < 0x20 } split(//, $href->{$key}));
+			dataerror("$preamble non-ASCII value for '$key'",
+					  "Only printable 7-bit ASCII characters are allowed as commandtag data")
+				if (grep { ord($_) > 0x7F } split(//, $href->{$key}));
+			dataerror("$preamble unrecognized field '$key'",
+					  "Recognized keys are @expected_keys")
+				unless $expected_keys{$key};
+		}
+
+		foreach my $flag (grep { exists $href->{$_} } @flag_keys)
+		{
+			my $val = $href->{$flag};
+			dataerror("$preamble empty or undefined value for '$flag'",
+					  "Fields with no value should simply be omitted")
+				unless defined $val and length $val;
+			dataerror("$preamble false value need not be specified for '$flag'",
+					  "Fields with false values should simply be omitted")
+				if ($val =~ m/^(?:false|f|0|off)$/i);
+			dataerror("$preamble unrecognized value for '$flag': '$val'")
+				unless ($val =~ m/^(?:true|t|1|on)$/i);
+		}
+	}
+}
+
+sub boilerplate_header
+{
+	my ($filename, $filedesc, $repo_path, $header_guard) = @_;
+	my $year = (localtime(time))[5] + 1900;
+	return
+"/*-------------------------------------------------------------------------
+ *
+ * $filename
+ *	  $filedesc
+ *
+ * Portions Copyright (c) 1996-$year, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * NOTES
+ *  ******************************
+ *  *** DO NOT EDIT THIS FILE! ***
+ *  ******************************
+ *
+ * It has been generated by src/backend/utils/gencommandtag.pl
+ *
+ * IDENTIFICATION
+ *	  $repo_path
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef $header_guard
+#define $header_guard";
+}
+
+sub boilerplate_footer
+{
+	my ($header_guard) = @_;
+	return "#endif				/* $header_guard */";
+}
+
+sub dataerror
+{
+	my ($errmsg, $errhint) = @_;
+	print STDERR "Error encountered while verifying $inputfile:\n";
+	print STDERR $errmsg, "\n";
+	if (defined $errhint)
+	{
+		print STDERR "HINT: ", $errhint, "\n";
+	}
+	print STDERR "Please fix $inputfile\n";
+	exit 1;
+}
+
+sub usage
+{
+	die <<EOM;
+Usage: perl gencommandtag.pl [--inputfile <file.dat>] [--outputdir <path>]
+
+Options:
+    --inputfile         Optional: Input commandtag data file
+                        (defaults to ../../include/utils/commandtag.dat)
+    --outputdir         Optional: Output directory for generated headers
+                        (defaults to current working directory)
+
+gencommandtag.pl generates the commandtag_enum.h and commandtag_behavior.h
+files from the specially formatted commandtag.dat data file.
+
+Report bugs to <pgsql-bugs\@lists.postgresql.org>.
+EOM
+}
diff --git a/src/backend/utils/mmgr/portalmem.c b/src/backend/utils/mmgr/portalmem.c
index b675575c31..00e8065342 100644
--- a/src/backend/utils/mmgr/portalmem.c
+++ b/src/backend/utils/mmgr/portalmem.c
@@ -281,7 +281,7 @@ void
 PortalDefineQuery(Portal portal,
 				  const char *prepStmtName,
 				  const char *sourceText,
-				  const char *commandTag,
+				  CommandTag commandTag,
 				  List *stmts,
 				  CachedPlan *cplan)
 {
@@ -289,10 +289,12 @@ PortalDefineQuery(Portal portal,
 	AssertState(portal->status == PORTAL_NEW);
 
 	AssertArg(sourceText != NULL);
-	AssertArg(commandTag != NULL || stmts == NIL);
+	AssertArg(commandTag != COMMANDTAG_UNKNOWN || stmts == NIL);
 
 	portal->prepStmtName = prepStmtName;
 	portal->sourceText = sourceText;
+	portal->qc.commandTag = commandTag;
+	portal->qc.nprocessed = 0;
 	portal->commandTag = commandTag;
 	portal->stmts = stmts;
 	portal->cplan = cplan;
diff --git a/src/include/Makefile b/src/include/Makefile
index c557375ae3..fadbd737c9 100644
--- a/src/include/Makefile
+++ b/src/include/Makefile
@@ -44,6 +44,8 @@ install: all installdirs
 	$(INSTALL_DATA) pg_config.h     '$(DESTDIR)$(includedir_server)'
 	$(INSTALL_DATA) pg_config_ext.h '$(DESTDIR)$(includedir_server)'
 	$(INSTALL_DATA) pg_config_os.h  '$(DESTDIR)$(includedir_server)'
+	$(INSTALL_DATA) utils/commandtag_enum.h '$(DESTDIR)$(includedir_server)/utils'
+	$(INSTALL_DATA) utils/commandtag_behavior.h '$(DESTDIR)$(includedir_server)/utils'
 	$(INSTALL_DATA) utils/errcodes.h '$(DESTDIR)$(includedir_server)/utils'
 	$(INSTALL_DATA) utils/fmgroids.h '$(DESTDIR)$(includedir_server)/utils'
 	$(INSTALL_DATA) utils/fmgrprotos.h '$(DESTDIR)$(includedir_server)/utils'
@@ -77,7 +79,7 @@ uninstall:
 
 
 clean:
-	rm -f utils/fmgroids.h utils/fmgrprotos.h utils/errcodes.h utils/header-stamp
+	rm -f utils/commandtag_enum.h utils/commandtag_behavior.h utils/fmgroids.h utils/fmgrprotos.h utils/errcodes.h utils/header-stamp
 	rm -f parser/gram.h storage/lwlocknames.h utils/probes.h
 	rm -f catalog/schemapg.h catalog/pg_*_d.h catalog/header-stamp
 
diff --git a/src/include/commands/createas.h b/src/include/commands/createas.h
index 7743851a38..5615b5ecac 100644
--- a/src/include/commands/createas.h
+++ b/src/include/commands/createas.h
@@ -22,7 +22,8 @@
 
 
 extern ObjectAddress ExecCreateTableAs(ParseState *pstate, CreateTableAsStmt *stmt,
-									   ParamListInfo params, QueryEnvironment *queryEnv, char *completionTag);
+									   ParamListInfo params, QueryEnvironment *queryEnv,
+									   QueryCompletion *qc);
 
 extern int	GetIntoRelEFlags(IntoClause *intoClause);
 
diff --git a/src/include/commands/event_trigger.h b/src/include/commands/event_trigger.h
index faa2958b89..5123c4b850 100644
--- a/src/include/commands/event_trigger.h
+++ b/src/include/commands/event_trigger.h
@@ -25,7 +25,7 @@ typedef struct EventTriggerData
 	NodeTag		type;
 	const char *event;			/* event name */
 	Node	   *parsetree;		/* parse tree */
-	const char *tag;			/* command tag */
+	CommandTag	tag;
 } EventTriggerData;
 
 #define AT_REWRITE_ALTER_PERSISTENCE	0x01
diff --git a/src/include/commands/matview.h b/src/include/commands/matview.h
index 6bdb7ca258..3ea4f5c80b 100644
--- a/src/include/commands/matview.h
+++ b/src/include/commands/matview.h
@@ -24,7 +24,7 @@
 extern void SetMatViewPopulatedState(Relation relation, bool newstate);
 
 extern ObjectAddress ExecRefreshMatView(RefreshMatViewStmt *stmt, const char *queryString,
-										ParamListInfo params, char *completionTag);
+										ParamListInfo params, QueryCompletion *qc);
 
 extern DestReceiver *CreateTransientRelDestReceiver(Oid oid);
 
diff --git a/src/include/commands/portalcmds.h b/src/include/commands/portalcmds.h
index 4ecc1a2ecd..41bb7c395b 100644
--- a/src/include/commands/portalcmds.h
+++ b/src/include/commands/portalcmds.h
@@ -22,8 +22,7 @@
 extern void PerformCursorOpen(ParseState *pstate, DeclareCursorStmt *cstmt, ParamListInfo params,
 							  bool isTopLevel);
 
-extern void PerformPortalFetch(FetchStmt *stmt, DestReceiver *dest,
-							   char *completionTag);
+extern void PerformPortalFetch(FetchStmt *stmt, DestReceiver *dest, QueryCompletion *qc);
 
 extern void PerformPortalClose(const char *name);
 
